#!/usr/local/bin/perl

#############################################################
#BooEasyPasswordChanger v1.05 / This program is free.       #
#(C) BooBooClub 2002-2010                                   #
#############################################################

#set_data
$htpasswd = './.htpasswd';
$title = 'BooEasyPasswordChanger';
$bgcolor = '#779977';
$tdbgcolor = '#99aa99';
$linkpath = './';
$linktext = '߂';



#read
if ($ENV{'REQUEST_METHOD'} eq "POST"){
	read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
}
else{
	$buffer = $ENV{'QUERY_STRING'};
}

@pairs = split(/&/,$buffer);
foreach $pair (@pairs) {
	($name, $value) = split(/=/, $pair);
	$value =~ tr/+/ /;
	$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	$value =~ s/\r\n|[\r\n]//ig;
	$FORM{$name} = $value;
}



#lock
&lock;



#allow

if($FORM{'change'}){
	&check;
	&change;
}
else{
	&html;
}



sub check{
	if(!$FORM{'id'} || !$FORM{'oldpass'} || !$FORM{'newpass'} || $FORM{'id'} =~ /\W/ || $FORM{'oldpass'} =~ /\W/ || $FORM{'newpass'} =~ /\W/){
		&error;
	}
}



sub change{
	open (USER,"$htpasswd");
	@ud = <USER>;
	close (USER);
	$i = 0;
	foreach $ud(@ud){
		($id,$cpass) = split(/:/,$ud);
		if($id eq $FORM{'id'}){
			chomp $cpass;
			if($cpass ne crypt ($FORM{'oldpass'},$cpass)){
				&pass_error;
			}
			srand(time|$$);
			@saltset = ('a' .. 'z', 'A' .. 'Z', '0' .. '9', '.', '/');
			$salt = $saltset[int(rand(64))];
			$salt .= $saltset[int(rand(64))];
			$passwd = crypt ($FORM{'newpass'},$salt);
			if($passwd eq crypt($FORM{'newpass'},$passwd)){
				$npass = "$id:$passwd\n";
				push (@nud,$npass);
				$i++;
			}
			else{
				print "Content-type:text/html\n\n";
				print '<html>'."\n";
				print '<head>'."\n";
				print '<meta http-equiv="content-type" content="text/html; charset=Shift_JIS">'."\n";
				print '<title>Error</title>'."\n";
				print '</head>'."\n";
				print "<body bgcolor=\"$bgcolor\" text=\"\#222222\"><center>\n";
				print "<br><br><br><br><br><h2>Error!</h2><br><br><br>\n";
				print 'G[܂B<br><br>uEŨobN{^Ŗ߂ĂB',"\n";
				print "<br></center></body></html>\n";
				unlink("$lockfile"); 
				exit 0;
			}
		}
		else{
			push(@nud,$ud);
		}
	}
	if($i != 1){
		&pass_error;
	}
	open (USER,">$htpasswd");
	print USER @nud;
	close (USER);
	&success;
}



sub html{
	print "Content-type:text/html\n\n";
	print '<html>'."\n";
	print '<head>'."\n";
	print '<meta http0-equiv="content-type" content="text/html; charset=Shift_JIS">'."\n";
	print '<title>'."$title".'</title>'."\n";
	print '</head>'."\n";
	print '<body bgcolor="'."$bgcolor".'">'."\n";
	print '<center>'."\n";
	print '<h2 align="center"><font color="#555555">'."$title".'</font></h2>'."\n";
	print ''."\n";
	print '<table cellspacing=10 cellpadding=5>'."\n";
	print '<tr><td bgcolor="'."$tdbgcolor".'" valign="top">'."\n";
	print '<form action="./bepc.cgi" method="POST">'."\n";
	print 'hcƌÂpX[hAVݒ肷pX[h͂A<br>'."\n";
	print 'ύX{^ĉB'."\n";
	print '<br><br>'."\n";
	print '<font color="#666666">'."\n";
	print ' pX[hύX<br><br>'."\n";
	print '<table>'."\n";
	print '<tr><td><font color="#666666">[Uhc</font></td><td><font color="#666666">F</font><input type=text size=10 maxlength=8 name=id></td></tr>'."\n";
	print '<tr><td><font color="#666666">pX[h</font></td><td><font color="#666666">F</font><input type=password size=10 maxlength=8 name=oldpass></td></tr>'."\n";
	print '<tr><td><font color="#666666">VpX[h</font></td><td><font color="#666666">F</font><input type=password size=10 maxlength=8 name=newpass></td></tr>'."\n";
	print '</table>'."\n";
	print ''."\n";
	print '<center>'."\n";
	print '<input type="submit" name="change" value="@ρ@X@">'."\n";
	print '</center>'."\n";
	print ''."\n";
	print '</td></tr></table>'."\n";
	print ''."\n";
	print '</center>'."\n";
	print '</body>'."\n";
	print '</html>'."\n";
	unlink("$lockfile"); 
	exit 0;
}



sub success {
	print "Content-type:text/html\n\n";
	print '<html>'."\n";
	print '<head>'."\n";
	print '<meta http0-equiv="content-type" content="text/html; charset=Shift_JIS">'."\n";
	print '<title>Success</title>'."\n";
	print '</head>'."\n";
	print "<body bgcolor=\"$bgcolor\" text=\"\#555555\"><center>\n";
	print "<br><br><br><br><br><h2>Success!</h2><br><br><br>\n";
	print 'ύX܂<br><br><a href="'."$linkpath".'">'."$linktext".'</a>',"\n";
	print "<br></center></body></html>\n";
	unlink("$lockfile"); 
	exit 0;
}



sub error {
	print "Content-type:text/html\n\n";
	print '<html>'."\n";
	print '<head>'."\n";
	print '<meta http0-equiv="content-type" content="text/html; charset=Shift_JIS">'."\n";
	print '<title>Error</title>'."\n";
	print '</head>'."\n";
	print "<body bgcolor=\"$bgcolor\" text=\"\#555555\"><center>\n";
	print "<br><br><br><br><br><h2>Error!</h2><br><br><br>\n";
	print 'hcpX[h̕ɖ肪܂<br><br>uEŨobN{^Ŗ߂ĂB',"\n";
	print "<br></center></body></html>\n";
	unlink("$lockfile"); 
	exit 0;
}



sub pass_error {
	print "Content-type:text/html\n\n";
	print '<html>'."\n";
	print '<head>'."\n";
	print '<meta http0-equiv="content-type" content="text/html; charset=Shift_JIS">'."\n";
	print '<title>Error</title>'."\n";
	print '</head>'."\n";
	print "<body bgcolor=\"$bgcolor\" text=\"\#555555\"><center>\n";
	print "<br><br><br><br><br><h2>Error!</h2><br><br><br>\n";
	print 'hcpX[hɌ肪܂<br><br>uEŨobN{^Ŗ߂ĂB',"\n";
	print "<br></center></body></html>\n";
	unlink("$lockfile"); 
	exit 0;
}



sub lock{
	$lockfile = './lock/lockfile';
	$retry = 1;
	until (symlink("$htpasswd", "$lockfile")){
		if (++$retry >= 30){
			unlink("$lockfile"); 
			exit 0;
		}
		sleep(1);
	}
}

